'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.editFeature = exports.updateFieldOrder = exports.updateVisibleFields = exports.redirectView = exports.switchView = exports.closeModal = exports.showFeatureDetail = exports.openSettings = exports.replaceMapStyle = exports.addFeatures = exports.replaceFeatures = exports.moveMap = exports.changeCoordinates = exports.updateFieldMapping = exports.updateVisibleFilters = exports.removeFilter = exports.updateFilter = undefined;

var _constants = require('./constants');

var updateFilter = exports.updateFilter = createActionCreator('UPDATE_FILTER');
var removeFilter = exports.removeFilter = createActionCreator('REMOVE_FILTER');
var updateVisibleFilters = exports.updateVisibleFilters = createActionCreator('UPDATE_VISIBLE_FILTERS');
var updateFieldMapping = exports.updateFieldMapping = createActionCreator('UPDATE_FIELD_MAPPING');
var changeCoordinates = exports.changeCoordinates = createActionCreator('CHANGE_COORDINATE_FORMAT');
var moveMap = exports.moveMap = createActionCreator('MOVE_MAP');
var replaceFeatures = exports.replaceFeatures = createActionCreator('REPLACE_FEATURES');
var addFeatures = exports.addFeatures = createActionCreator('ADD_FEATURES');
var replaceMapStyle = exports.replaceMapStyle = createActionCreator('REPLACE_MAP_STYLE');
var openSettings = exports.openSettings = createActionCreator('OPEN_SETTINGS');
var showFeatureDetail = exports.showFeatureDetail = createActionCreator('SHOW_FEATURE_DETAIL');
var closeModal = exports.closeModal = createActionCreator('CLOSE_MODAL');
var switchView = exports.switchView = createActionCreator('SWITCH_VIEW');
var redirectView = exports.redirectView = createActionCreator('REDIRECT_VIEW');
var updateVisibleFields = exports.updateVisibleFields = createActionCreator(_constants.UPDATE_VISIBLE_FIELDS);
var updateFieldOrder = exports.updateFieldOrder = createActionCreator(_constants.UPDATE_FIELD_ORDER);
var editFeature = exports.editFeature = createActionCreator(_constants.EDIT_FEATURE);

function createActionCreator(type) {
  return function (payload) {
    return { type: type, payload: payload };
  };
}
//# sourceMappingURL=action_creators.js.map