'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.PrintButton = exports.SettingsButton = undefined;

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _IconButton = require('material-ui/IconButton');

var _IconButton2 = _interopRequireDefault(_IconButton);

var _Settings = require('material-ui-icons/Settings');

var _Settings2 = _interopRequireDefault(_Settings);

var _Tooltip = require('material-ui/Tooltip');

var _Tooltip2 = _interopRequireDefault(_Tooltip);

var _Print = require('material-ui-icons/Print');

var _Print2 = _interopRequireDefault(_Print);

var _reactIntl = require('react-intl');

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

var messages = (0, _reactIntl.defineMessages)({
  settings: {
    'id': 'buttons.settings',
    'defaultMessage': 'Settings'
  },
  print: {
    'id': 'buttons.print',
    'defaultMessage': 'Print'
  }
});

var SettingsButton = (0, _reactIntl.injectIntl)(function (_ref) {
  var openSettings = _ref.openSettings,
      intl = _ref.intl;

  var name = intl.formatMessage(messages.settings);
  return _react2.default.createElement(
    _Tooltip2.default,
    { title: name },
    _react2.default.createElement(
      _IconButton2.default,
      { onClick: openSettings.bind(null, 'general'), 'aria-label': name },
      _react2.default.createElement(_Settings2.default, { color: 'white' })
    )
  );
});

var PrintButton = (0, _reactIntl.injectIntl)(function (_ref2) {
  var intl = _ref2.intl;

  var name = intl.formatMessage(messages.print);
  return _react2.default.createElement(
    _Tooltip2.default,
    { title: name },
    _react2.default.createElement(
      _IconButton2.default,
      { onClick: function onClick() {
          return window.print();
        }, 'aria-label': name },
      _react2.default.createElement(_Print2.default, { color: 'white' })
    )
  );
});

exports.SettingsButton = SettingsButton;
exports.PrintButton = PrintButton;
//# sourceMappingURL=index.js.map