'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _keys = require('babel-runtime/core-js/object/keys');

var _keys2 = _interopRequireDefault(_keys);

var _defineProperty2 = require('babel-runtime/helpers/defineProperty');

var _defineProperty3 = _interopRequireDefault(_defineProperty2);

var _getPrototypeOf = require('babel-runtime/core-js/object/get-prototype-of');

var _getPrototypeOf2 = _interopRequireDefault(_getPrototypeOf);

var _classCallCheck2 = require('babel-runtime/helpers/classCallCheck');

var _classCallCheck3 = _interopRequireDefault(_classCallCheck2);

var _createClass2 = require('babel-runtime/helpers/createClass');

var _createClass3 = _interopRequireDefault(_createClass2);

var _possibleConstructorReturn2 = require('babel-runtime/helpers/possibleConstructorReturn');

var _possibleConstructorReturn3 = _interopRequireDefault(_possibleConstructorReturn2);

var _inherits2 = require('babel-runtime/helpers/inherits');

var _inherits3 = _interopRequireDefault(_inherits2);

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _reactRedux = require('react-redux');

var _Card = require('material-ui/Card');

var _Paper = require('material-ui/Paper');

var _Paper2 = _interopRequireDefault(_Paper);

var _Button = require('material-ui/Button');

var _Button2 = _interopRequireDefault(_Button);

var _styles = require('material-ui/styles');

var _ModeEdit = require('material-ui-icons/ModeEdit');

var _ModeEdit2 = _interopRequireDefault(_ModeEdit);

var _reactIntl = require('react-intl');

var _objectAssign = require('object-assign');

var _objectAssign2 = _interopRequireDefault(_objectAssign);

var _flat = require('flat');

var _classnames = require('classnames');

var _classnames2 = _interopRequireDefault(_classnames);

var _features_by_id = require('../../selectors/features_by_id');

var _features_by_id2 = _interopRequireDefault(_features_by_id);

var _field_mapping = require('../../selectors/field_mapping');

var _field_mapping2 = _interopRequireDefault(_field_mapping);

var _visible_fields = require('../../selectors/visible_fields');

var _visible_fields2 = _interopRequireDefault(_visible_fields);

var _field_analysis = require('../../selectors/field_analysis');

var _field_analysis2 = _interopRequireDefault(_field_analysis);

var _image = require('../image');

var _image2 = _interopRequireDefault(_image);

var _table = require('../shared/table');

var _table2 = _interopRequireDefault(_table);

var _action_creators = require('../../action_creators');

var _constants = require('../../constants');

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

var styleSheet = {
  card: {
    width: '100%',
    position: 'relative'
  },
  cardUnrestricted: {
    width: '100%'
  },
  header: {
    lineHeight: '22px',
    boxSizing: 'content-box',
    borderBottom: '1px solid #cccccc'
  },
  markerIcon: {
    width: 40,
    height: 40,
    margin: 0,
    marginRight: 16
  },
  media: {
    position: 'relative',
    height: '100%',
    padding: '67% 0 0 0'
  },
  img: {
    width: '100%',
    height: '100%',
    top: 0,
    left: 0,
    position: 'absolute',
    objectFit: 'cover',
    transform: 'translate3d(0,0,0)'
  },
  button: {
    margin: '8px 16px 8px 8px'
  },
  closeButton: {
    position: 'absolute',
    top: 15,
    right: 5
  },
  actions: {
    justifyContent: 'flex-end',
    paddingBottom: 8
  }
};

var messages = (0, _reactIntl.defineMessages)({
  editButton: {
    'id': 'feature.editButton',
    'defaultMessage': 'Edit'
  },
  closeButton: {
    'id': 'feature.closeButton',
    'defaultMessage': 'Close'
  },
  cancelButton: {
    'id': 'feature.cancelButton',
    'defaultMessage': 'Cancel'
  },
  saveButton: {
    'id': 'feature.saveButton',
    'defaultMessage': 'Save'
  }
});

var Actions = function Actions(_ref) {
  var editMode = _ref.editMode,
      onCloseClick = _ref.onCloseClick,
      onEditClick = _ref.onEditClick,
      onCancelClick = _ref.onCancelClick,
      onSaveClick = _ref.onSaveClick,
      classes = _ref.classes;
  return editMode ? _react2.default.createElement(
    _Card.CardActions,
    { className: classes.actions },
    _react2.default.createElement(
      _Button2.default,
      {
        raised: true,
        onClick: onCancelClick,
        className: classes.button
      },
      _react2.default.createElement(_reactIntl.FormattedMessage, messages.cancelButton)
    ),
    _react2.default.createElement(
      _Button2.default,
      {
        raised: true,
        color: 'primary',
        onClick: onSaveClick,
        className: classes.button
      },
      _react2.default.createElement(_reactIntl.FormattedMessage, messages.saveButton)
    )
  ) : _react2.default.createElement(
    _Card.CardActions,
    { className: classes.actions },
    _react2.default.createElement(
      _Button2.default,
      {
        raised: true,
        icon: _react2.default.createElement(_ModeEdit2.default, null),
        onClick: onEditClick,
        className: classes.button
      },
      _react2.default.createElement(_reactIntl.FormattedMessage, messages.editButton)
    ),
    _react2.default.createElement(
      _Button2.default,
      {
        raised: true,
        color: 'primary',
        onClick: onCloseClick,
        className: classes.button
      },
      _react2.default.createElement(_reactIntl.FormattedMessage, messages.closeButton)
    )
  );
};

var FeatureDetail = function (_React$Component) {
  (0, _inherits3.default)(FeatureDetail, _React$Component);

  function FeatureDetail(props) {
    (0, _classCallCheck3.default)(this, FeatureDetail);

    var _this = (0, _possibleConstructorReturn3.default)(this, (FeatureDetail.__proto__ || (0, _getPrototypeOf2.default)(FeatureDetail)).call(this, props));

    _this.state = {
      editMode: false
    };
    _this.handleEditClick = _this.handleEditClick.bind(_this);
    _this.handleCancelClick = _this.handleCancelClick.bind(_this);
    _this.handleSaveClick = _this.handleSaveClick.bind(_this);
    _this.handleValueChange = _this.handleValueChange.bind(_this);
    _this.handleVisibilityChange = _this.handleVisibilityChange.bind(_this);
    return _this;
  }

  (0, _createClass3.default)(FeatureDetail, [{
    key: 'handleEditClick',
    value: function handleEditClick() {
      this.setState({
        editMode: true,
        feature: this.props.feature,
        visibleFields: this.props.visibleFields
      });
    }
  }, {
    key: 'handleCancelClick',
    value: function handleCancelClick() {
      this.setState({ editMode: false });
    }
  }, {
    key: 'handleSaveClick',
    value: function handleSaveClick() {
      if (this.state.feature !== this.props.feature) {
        var newFeature = untransformFeature(this.state.feature, this.props.fieldAnalysis);
        this.props.onEditFeature(newFeature);
      }
      if (this.state.visibleFields !== this.props.visibleFields) {
        this.props.onEditHiddenFields(this.state.visibleFields);
      }
      this.setState({ editMode: false });
    }
  }, {
    key: 'handleVisibilityChange',
    value: function handleVisibilityChange(key, visible) {
      var visibleFields = visible ? this.state.visibleFields.concat([key]) : this.state.visibleFields.filter(function (fieldname) {
        return fieldname !== key;
      });
      this.setState({ visibleFields: visibleFields });
    }
  }, {
    key: 'handleValueChange',
    value: function handleValueChange(key, value) {
      var feature = this.state.feature;
      var newFeature = (0, _objectAssign2.default)({}, feature, {
        properties: (0, _objectAssign2.default)({}, feature.properties, (0, _defineProperty3.default)({}, key, value))
      });
      this.setState({ feature: newFeature });
    }
  }, {
    key: 'render',
    value: function render() {
      var _props = this.props,
          media = _props.media,
          feature = _props.feature,
          onCloseClick = _props.onCloseClick,
          fieldOrder = _props.fieldOrder,
          classes = _props.classes,
          className = _props.className,
          coordFormat = _props.coordFormat,
          fieldAnalysis = _props.fieldAnalysis,
          visibleFields = _props.visibleFields;
      var _state = this.state,
          editMode = _state.editMode,
          editedFeature = _state.feature,
          editedVisibleFields = _state.visibleFields;

      return _react2.default.createElement(
        _Paper2.default,
        { className: (0, _classnames2.default)(classes.card, className), elevation: 8 },
        media && _react2.default.createElement(
          'div',
          { className: classes.media },
          _react2.default.createElement(_image2.default, { className: classes.img, src: media })
        ),
        _react2.default.createElement(_table2.default, {
          editMode: editMode,
          feature: editMode ? editedFeature : feature,
          fieldAnalysis: fieldAnalysis,
          fieldOrder: fieldOrder,
          visibleFields: editMode ? editedVisibleFields : visibleFields,
          coordFormat: coordFormat,
          onVisibilityChange: this.handleVisibilityChange,
          onValueChange: this.handleValueChange
        }),
        _react2.default.createElement(Actions, {
          classes: classes,
          style: { textAlign: 'right' },
          editMode: editMode,
          onChangeProp: this.handlePropEdit,
          onEditClick: this.handleEditClick,
          onCloseClick: onCloseClick,
          onCancelClick: this.handleCancelClick,
          onSaveClick: this.handleSaveClick
        })
      );
    }
  }]);
  return FeatureDetail;
}(_react2.default.Component);

// The selectors transform input features, we want to undo this before we save


function untransformFeature(feature, fieldAnalysis) {
  var newProps = {};
  var prevProps = feature.properties;
  (0, _keys2.default)(prevProps).forEach(function (key) {
    if (typeof prevProps[key] === 'string') {
      newProps[key] = prevProps[key].trim();
    }
    switch (fieldAnalysis.properties[key].type) {
      case _constants.FIELD_TYPE_SPACE_DELIMITED:
        newProps[key] = Array.isArray(prevProps[key]) ? prevProps[key].join(' ') : prevProps[key];
        break;
      default:
        newProps[key] = prevProps[key];
    }
  });
  return (0, _flat.unflatten)((0, _objectAssign2.default)({}, feature, {
    properties: newProps
  }));
}

exports.default = (0, _reactRedux.connect)(function (state, ownProps) {
  var featuresById = (0, _features_by_id2.default)(state);
  var fieldMapping = (0, _field_mapping2.default)(state);
  var visibleFields = (0, _visible_fields2.default)(state);
  var fieldAnalysis = (0, _field_analysis2.default)(state);
  var id = ownProps.id || state.ui.featureId;
  var feature = featuresById[id];
  if (!feature) return {};
  var geojsonProps = feature.properties;
  return {
    coordFormat: state.settings.coordFormat,
    feature: feature,
    fieldAnalysis: fieldAnalysis,
    fieldOrder: state.fieldOrder,
    visibleFields: visibleFields,
    media: geojsonProps[fieldMapping.media]
  };
}, function (dispatch) {
  return {
    onEditFeature: function onEditFeature(feature) {
      return dispatch((0, _action_creators.editFeature)(feature));
    },
    onEditHiddenFields: function onEditHiddenFields(visibleFields) {
      return dispatch((0, _action_creators.updateVisibleFields)(visibleFields));
    }
  };
})((0, _styles.withStyles)(styleSheet)(FeatureDetail));
//# sourceMappingURL=index.js.map