'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _extends2 = require('babel-runtime/helpers/extends');

var _extends3 = _interopRequireDefault(_extends2);

var _getPrototypeOf = require('babel-runtime/core-js/object/get-prototype-of');

var _getPrototypeOf2 = _interopRequireDefault(_getPrototypeOf);

var _classCallCheck2 = require('babel-runtime/helpers/classCallCheck');

var _classCallCheck3 = _interopRequireDefault(_classCallCheck2);

var _createClass2 = require('babel-runtime/helpers/createClass');

var _createClass3 = _interopRequireDefault(_createClass2);

var _possibleConstructorReturn2 = require('babel-runtime/helpers/possibleConstructorReturn');

var _possibleConstructorReturn3 = _interopRequireDefault(_possibleConstructorReturn2);

var _inherits2 = require('babel-runtime/helpers/inherits');

var _inherits3 = _interopRequireDefault(_inherits2);

var _propTypes = require('prop-types');

var _propTypes2 = _interopRequireDefault(_propTypes);

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _Paper = require('material-ui/Paper');

var _Paper2 = _interopRequireDefault(_Paper);

var _insertCss = require('insert-css');

var _insertCss2 = _interopRequireDefault(_insertCss);

var _Typography = require('material-ui/Typography');

var _Typography2 = _interopRequireDefault(_Typography);

var _feature = require('./feature');

var _feature2 = _interopRequireDefault(_feature);

var _prop_types = require('../../util/prop_types');

var MFPropTypes = _interopRequireWildcard(_prop_types);

var _map = require('../map');

var _map2 = _interopRequireDefault(_map);

var _alert = require('./alert');

var _alert2 = _interopRequireDefault(_alert);

var _config = require('../../../config.json');

var _config2 = _interopRequireDefault(_config);

function _interopRequireWildcard(obj) { if (obj && obj.__esModule) { return obj; } else { var newObj = {}; if (obj != null) { for (var key in obj) { if (Object.prototype.hasOwnProperty.call(obj, key)) newObj[key] = obj[key]; } } newObj.default = obj; return newObj; } }

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

// import {FIELD_TYPE_DATE} from '../../constants'

(0, _insertCss2.default)('\n.report_header {\n  position: relative;\n  min-width: calc(8.5in + 40px);\n  z-index: 1;\n}\n.report_wrapper {\n  overflow: scroll;\n  position: absolute;\n  background-color: rgba(236, 236, 236, 1);\n  width: 100%;\n  height: 100%;\n}\n.report_container {\n  min-width: 8.5in;\n  padding: 0 20px\n}\n.report_paper {\n  cursor: pointer;\n  margin: 20px auto;\n  width: 8.5in;\n  overflow: hidden;\n  page-break-after: always;\n  background-color: initial;\n  position: relative;\n}\n.report_paper:last-child {\n  page-break-after: avoid !important;\n}\n.map_container {\n  flex: 1;\n  position: relative;\n}\n.page_break {\n  position: absolute;\n  left: 0;\n  top: 10.5in;\n  width: 100%;\n  border: none;\n  margin: 0;\n  border-bottom: 3px dashed rgba(200,200,200, 0.75);\n}\n\n.report_page {\n  margin: 0.5in;\n  min-height: 10in;\n  outline: 1px dashed #eeeeee;\n}\n@page {\n  margin: 0.5in;\n}\n.report_paper:first-child {\n  cursor: auto;\n  display: flex;\n  height: calc(11in - 2px);\n}\n.report_paper:first-child .report_page {\n  flex: 1;\n  display: flex;\n  flex-direction: column;\n}\n@media only print {\n  body, html {\n    overflow: visible;\n  }\n  /* Override display: flex which breaks page-break-after */\n  /* Fix for page-break-after not working in Chrome see http://stackoverflow.com/questions/4884380/css-page-break-not-working-in-all-browsers/5314590 */\n  div {\n    float: none !important;\n  }\n  tr {\n    page-break-inside: avoid;\n  }\n  .report_wrapper {\n    position: relative;\n    width: auto;\n    height: auto;\n    background-color: initial;\n  }\n  .report_container {\n    display: block;\n    padding: 0;\n    overflow: visible;\n  }\n  .report_paper {\n    min-height: auto;\n    box-shadow: none !important;\n    border-radius: 0 !important;\n    margin: 0;\n    /* for some reason we need to substract 2px for a perfect fit */\n    width: calc(7.5in - 2px);\n  }\n  .report_paper:first-child {\n    height: calc(10in - 2px);\n  }\n  .no_print {\n    display: none;\n  }\n  .report_page {\n    min-height: auto;\n    margin: 0;\n    outline: none;\n  }\n  /* TODO include some form of MapFilter header */\n  /* TODO rotate the filter display and show state vs. allow interaction */\n  .mapboxgl-control-container,\n  .nav.container,\n  .page_break,\n  .report_header,\n  .filter {\n    display: none !important;\n  }\n}\n');

var MAX_REPORT_LEN = 26;

var ReportView = function (_React$Component) {
  (0, _inherits3.default)(ReportView, _React$Component);

  function ReportView() {
    (0, _classCallCheck3.default)(this, ReportView);
    return (0, _possibleConstructorReturn3.default)(this, (ReportView.__proto__ || (0, _getPrototypeOf2.default)(ReportView)).apply(this, arguments));
  }

  (0, _createClass3.default)(ReportView, [{
    key: 'render',
    value: function render() {
      var _this2 = this;

      var _props = this.props,
          filteredFeatures = _props.filteredFeatures,
          showFeatureDetail = _props.showFeatureDetail;

      var featuresSlice = filteredFeatures.length > MAX_REPORT_LEN ? filteredFeatures.slice(0, MAX_REPORT_LEN) : filteredFeatures;
      return _react2.default.createElement(
        'div',
        { className: 'report_wrapper' },
        _react2.default.createElement(
          'div',
          { className: 'report_header' },
          filteredFeatures.length > MAX_REPORT_LEN && _react2.default.createElement(_alert2.default, { label: 'Current filters show ' + filteredFeatures.length + ' records, a report will only show the first ' + MAX_REPORT_LEN + ' records' })
        ),
        _react2.default.createElement(
          'div',
          { className: 'report_container' },
          _react2.default.createElement(
            _Paper2.default,
            { className: 'report_paper', elevation: 1 },
            _react2.default.createElement(
              'div',
              { className: 'report_page' },
              _react2.default.createElement(
                'header',
                { className: 'map_header' },
                _react2.default.createElement(
                  _Typography2.default,
                  { type: 'title' },
                  'Monitoring Report'
                ),
                _react2.default.createElement(
                  _Typography2.default,
                  { type: 'subheading', style: { marginBottom: '0.5em' } },
                  featuresSlice.length,
                  ' locations'
                )
              ),
              _react2.default.createElement(
                'div',
                { className: 'map_container' },
                _react2.default.createElement(_map2.default, (0, _extends3.default)({}, this.props, {
                  features: featuresSlice,
                  interactive: false,
                  labelPoints: true
                }))
              )
            )
          ),
          featuresSlice.map(function (feature, i) {
            return _react2.default.createElement(
              _Paper2.default,
              { className: 'report_paper', key: i, onClick: function onClick() {
                  return showFeatureDetail(feature.id);
                }, elevation: 1 },
              _react2.default.createElement(
                'div',
                { className: 'report_page' },
                _react2.default.createElement(_feature2.default, (0, _extends3.default)({}, _this2.props, {
                  feature: feature,
                  label: _config2.default.labelChars.charAt(i)
                }))
              ),
              _react2.default.createElement('hr', { className: 'page_break' })
            );
          }),
          featuresSlice.length > MAX_REPORT_LEN && _react2.default.createElement(
            _Paper2.default,
            { className: 'report_paper' },
            _react2.default.createElement(
              'div',
              { className: 'report_page' },
              _react2.default.createElement(
                'h2',
                null,
                'Cannot print more than 26 observations in a single report'
              )
            )
          )
        )
      );
    }
  }]);
  return ReportView;
}(_react2.default.Component);

ReportView.propTypes = {
  filteredFeatures: _propTypes2.default.arrayOf(MFPropTypes.mapViewFeature).isRequired,
  fieldMapping: MFPropTypes.fieldMapping,
  filter: MFPropTypes.mapboxFilter
};
exports.default = ReportView;
//# sourceMappingURL=index.js.map