'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _getPrototypeOf = require('babel-runtime/core-js/object/get-prototype-of');

var _getPrototypeOf2 = _interopRequireDefault(_getPrototypeOf);

var _classCallCheck2 = require('babel-runtime/helpers/classCallCheck');

var _classCallCheck3 = _interopRequireDefault(_classCallCheck2);

var _createClass2 = require('babel-runtime/helpers/createClass');

var _createClass3 = _interopRequireDefault(_createClass2);

var _possibleConstructorReturn2 = require('babel-runtime/helpers/possibleConstructorReturn');

var _possibleConstructorReturn3 = _interopRequireDefault(_possibleConstructorReturn2);

var _inherits2 = require('babel-runtime/helpers/inherits');

var _inherits3 = _interopRequireDefault(_inherits2);

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _propTypes = require('prop-types');

var _propTypes2 = _interopRequireDefault(_propTypes);

var _styles = require('material-ui/styles');

var _Chip = require('material-ui/Chip');

var _Chip2 = _interopRequireDefault(_Chip);

var _select = require('./select');

var _select2 = _interopRequireDefault(_select);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

var styleSheet = {
  row: {
    display: 'flex',
    flexWrap: 'wrap',
    marginTop: -3
  },
  chip: {
    margin: '3px 3px 0 0',
    height: 30
  },
  select: {
    minWidth: 220
  },
  highlight: {
    backgroundColor: '#ff9696'
  }
};

var MultiSelect = function (_Component) {
  (0, _inherits3.default)(MultiSelect, _Component);

  function MultiSelect(props) {
    (0, _classCallCheck3.default)(this, MultiSelect);

    var _this = (0, _possibleConstructorReturn3.default)(this, (MultiSelect.__proto__ || (0, _getPrototypeOf2.default)(MultiSelect)).call(this, props));

    _this.state = {
      selectValue: '',
      suggestions: props.suggestions.filter(function (s) {
        return props.value.indexOf(s) === -1;
      })
    };
    _this.handleRequestDelete = _this.handleRequestDelete.bind(_this);
    _this.handleSelectChange = _this.handleSelectChange.bind(_this);
    _this.handleKeyDown = _this.handleKeyDown.bind(_this);
    _this.handleSuggestionSelected = _this.handleSuggestionSelected.bind(_this);
    return _this;
  }

  (0, _createClass3.default)(MultiSelect, [{
    key: 'componentWillReceiveProps',
    value: function componentWillReceiveProps(nextProps) {
      if (nextProps.value !== this.props.value) {
        var suggestions = nextProps.suggestions.filter(function (s) {
          return nextProps.value.indexOf(s) === -1;
        });
        this.setState({ suggestions: suggestions });
      }
    }
  }, {
    key: 'handleSelectChange',
    value: function handleSelectChange(e, d) {
      this.setState({ selectValue: d.newValue });
    }
  }, {
    key: 'handleKeyDown',
    value: function handleKeyDown(e) {
      if (this.justAdded || e.keyCode !== 13) {
        this.justAdded = false;
        return;
      }
      var newValue = this.state.selectValue;
      var index = this.props.value.indexOf(newValue);
      if (index > -1) {
        this.highlightChip(index);
        this.setState({ selectValue: '' });
      } else {
        this.handleSuggestionSelected(e, { suggestionValue: newValue });
      }
    }
  }, {
    key: 'handleSuggestionSelected',
    value: function handleSuggestionSelected(e, d) {
      var newValue = this.props.value.concat(d.suggestionValue);
      this.justAdded = true;
      this.setState({ selectValue: '' });
      this.props.onChange(e, { newValue: newValue, type: 'add' });
    }
  }, {
    key: 'handleRequestDelete',
    value: function handleRequestDelete(i) {
      var _this2 = this;

      return function (e) {
        var value = _this2.props.value;

        var newValue = value.slice(0, i).concat(value.slice(i + 1));
        _this2.props.onChange(e, { newValue: newValue, type: 'delete' });
      };
    }
  }, {
    key: 'highlightChip',
    value: function highlightChip(i) {
      var _this3 = this;

      this.setState({ highlight: i });
      setTimeout(function () {
        return _this3.setState({ highlight: null });
      }, 500);
    }
  }, {
    key: 'render',
    value: function render() {
      var _this4 = this;

      var _props = this.props,
          classes = _props.classes,
          value = _props.value;

      return _react2.default.createElement(
        'div',
        { className: classes.row },
        value.map(function (d, i) {
          return _react2.default.createElement(_Chip2.default, {
            label: d,
            key: i,
            onRequestDelete: _this4.handleRequestDelete(i),
            className: classes.chip + (_this4.state.highlight === i ? ' ' + classes.highlight : '')
          });
        }),
        _react2.default.createElement(_select2.default, {
          value: this.state.selectValue,
          suggestions: this.state.suggestions,
          onChange: this.handleSelectChange,
          onKeyDown: this.handleKeyDown,
          onSuggestionSelected: this.handleSuggestionSelected,
          className: classes.select
        })
      );
    }
  }]);
  return MultiSelect;
}(_react.Component);

MultiSelect.propTypes = {
  classes: _propTypes2.default.object.isRequired,
  className: _propTypes2.default.string,
  value: _propTypes2.default.array
};

MultiSelect.defaultProps = {
  value: []
};

exports.default = (0, _styles.withStyles)(styleSheet)(MultiSelect);
//# sourceMappingURL=multi_select.js.map