'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _keys = require('babel-runtime/core-js/object/keys');

var _keys2 = _interopRequireDefault(_keys);

var _defineProperty2 = require('babel-runtime/helpers/defineProperty');

var _defineProperty3 = _interopRequireDefault(_defineProperty2);

var _shouldNotWrap;

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _Typography = require('material-ui/Typography');

var _Typography2 = _interopRequireDefault(_Typography);

var _styles = require('material-ui/styles');

var _AutoSizer = require('react-virtualized/dist/commonjs/AutoSizer');

var _AutoSizer2 = _interopRequireDefault(_AutoSizer);

var _Table = require('material-ui/Table');

var _Table2 = _interopRequireDefault(_Table);

var _objectAssign = require('object-assign');

var _objectAssign2 = _interopRequireDefault(_objectAssign);

var _classnames = require('classnames');

var _classnames2 = _interopRequireDefault(_classnames);

var _formatted_value = require('../shared/formatted_value');

var _formatted_value2 = _interopRequireDefault(_formatted_value);

var _formatted_fieldname = require('../shared/formatted_fieldname');

var _formatted_fieldname2 = _interopRequireDefault(_formatted_fieldname);

var _IconButton = require('material-ui/IconButton');

var _IconButton2 = _interopRequireDefault(_IconButton);

var _Visibility = require('material-ui-icons/Visibility');

var _Visibility2 = _interopRequireDefault(_Visibility);

var _VisibilityOff = require('material-ui-icons/VisibilityOff');

var _VisibilityOff2 = _interopRequireDefault(_VisibilityOff);

var _TextField = require('material-ui/TextField');

var _TextField2 = _interopRequireDefault(_TextField);

var _Input = require('material-ui/Input');

var _Input2 = _interopRequireDefault(_Input);

var _Menu = require('material-ui/Menu');

var _Select = require('material-ui/Select');

var _Select2 = _interopRequireDefault(_Select);

var _select = require('../shared/select');

var _select2 = _interopRequireDefault(_select);

var _multi_select = require('../shared/multi_select');

var _multi_select2 = _interopRequireDefault(_multi_select);

var _pure = require('recompose/pure');

var _pure2 = _interopRequireDefault(_pure);

var _Tooltip = require('material-ui/Tooltip');

var _Tooltip2 = _interopRequireDefault(_Tooltip);

var _reactIntl = require('react-intl');

var _constants = require('../../constants');

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

var messages = (0, _reactIntl.defineMessages)({
  visibility: {
    'id': 'featureDetail.visibilitySwitch',
    'defaultMessage': 'Hide or show field'
  }
});

var styles = {
  root: {
    overflow: 'auto'
  },
  row: {
    verticalAlign: 'top',
    position: 'relative'
  },
  col1: {
    padding: '14px 12px 14px 24px'
  },
  col1Text: {
    fontWeight: 500,
    textOverflow: 'ellipsis',
    overflow: 'hidden'
  },
  col2: {
    padding: '14px 24px 14px 12px !important',
    width: '100%',
    maxWidth: 0,
    whiteSpace: 'initial',
    fontSize: '0.875rem'
  },
  col2Edit: {
    paddingTop: '9px !important',
    paddingBottom: '9px !important'
  },
  col2TextEdit: {
    paddingTop: 5,
    paddingBottom: 5
  },
  col2TextNoWrap: {
    overflow: 'hidden',
    whiteSpace: 'nowrap',
    textOverflow: 'ellipsis'
  },
  col3: {
    paddingLeft: 0,
    paddingRight: 12
  }
};

var shouldNotWrap = (_shouldNotWrap = {}, (0, _defineProperty3.default)(_shouldNotWrap, _constants.FIELD_TYPE_UUID, true), (0, _defineProperty3.default)(_shouldNotWrap, _constants.FIELD_TYPE_MIXED, true), (0, _defineProperty3.default)(_shouldNotWrap, _constants.FIELD_TYPE_IMAGE, true), (0, _defineProperty3.default)(_shouldNotWrap, _constants.FIELD_TYPE_VIDEO, true), (0, _defineProperty3.default)(_shouldNotWrap, _constants.FIELD_TYPE_MEDIA, true), (0, _defineProperty3.default)(_shouldNotWrap, _constants.FIELD_TYPE_AUDIO, true), _shouldNotWrap);

var ValueCell = function ValueCell(_ref) {
  var _classNames;

  var value = _ref.value,
      type = _ref.type,
      coordFormat = _ref.coordFormat,
      editMode = _ref.editMode,
      classes = _ref.classes;
  return _react2.default.createElement(
    _Typography2.default,
    { className: (0, _classnames2.default)((_classNames = {}, (0, _defineProperty3.default)(_classNames, classes.col2TextEdit, editMode), (0, _defineProperty3.default)(_classNames, classes.col2TextNoWrap, shouldNotWrap[type]), _classNames)) },
    _react2.default.createElement(_formatted_value2.default, { value: value, type: type, coordFormat: coordFormat })
  );
};

var ValueCellEdit = (0, _pure2.default)(function (_ref2) {
  var value = _ref2.value,
      type = _ref2.type,
      coordFormat = _ref2.coordFormat,
      _ref2$fieldMetadata = _ref2.fieldMetadata,
      fieldMetadata = _ref2$fieldMetadata === undefined ? {} : _ref2$fieldMetadata,
      _onChange = _ref2.onChange,
      classes = _ref2.classes;

  var suggestions = Array.isArray(fieldMetadata.values) && fieldMetadata.values.map(function (d) {
    return d.value;
  });
  var isDiscreteField = type === _constants.FIELD_TYPE_STRING && fieldMetadata.values && fieldMetadata.values.length / fieldMetadata.count < 0.8;
  if (isDiscreteField) {
    return _react2.default.createElement(_select2.default, {
      value: value,
      onChange: _onChange,
      suggestions: suggestions,
      style: styles.selectField });
  }
  if (type === _constants.FIELD_TYPE_BOOLEAN) {
    return _react2.default.createElement(
      _Select2.default,
      {
        MenuProps: { MenuListProps: { dense: true } },
        fullWidth: true,
        autoWidth: true,
        value: value + '',
        onChange: function onChange(e) {
          var newValue = e.target.value === 'true' ? true : e.target.value === 'false' ? false : undefined;
          _onChange(e, { newValue: newValue });
        },
        input: _react2.default.createElement(_Input2.default, null),
        style: styles.muiSelect },
      _react2.default.createElement(_Menu.MenuItem, { value: 'undefined' }),
      _react2.default.createElement(
        _Menu.MenuItem,
        { value: 'true' },
        'Yes'
      ),
      _react2.default.createElement(
        _Menu.MenuItem,
        { value: 'false' },
        'No'
      )
    );
  }
  if (type === _constants.FIELD_TYPE_STRING || type === _constants.FIELD_TYPE_MIXED) {
    return _react2.default.createElement(_TextField2.default, {
      fullWidth: true,
      multiline: true,
      value: value,
      onChange: function onChange(e) {
        return _onChange(e, { newValue: e.target.value, method: 'type' });
      },
      style: styles.textField });
  }
  if (type === _constants.FIELD_TYPE_ARRAY) {
    return _react2.default.createElement(_multi_select2.default, {
      value: value,
      onChange: _onChange,
      suggestions: suggestions,
      style: styles.selectField });
  }
  return _react2.default.createElement(ValueCell, { value: value, type: type, coordFormat: coordFormat, editMode: true, classes: classes });
});

var FeatureTable = function FeatureTable(_ref3) {
  var editMode = _ref3.editMode,
      classes = _ref3.classes,
      coordFormat = _ref3.coordFormat,
      feature = _ref3.feature,
      fieldAnalysis = _ref3.fieldAnalysis,
      visibleFields = _ref3.visibleFields,
      fieldOrder = _ref3.fieldOrder,
      onValueChange = _ref3.onValueChange,
      onVisibilityChange = _ref3.onVisibilityChange;

  var rows = getRows(feature, fieldAnalysis, visibleFields, fieldOrder, editMode);
  return _react2.default.createElement(
    _AutoSizer2.default,
    { disableHeight: true },
    function (_ref4) {
      var width = _ref4.width;
      return _react2.default.createElement(
        _Table2.default,
        { className: classes.root, style: { width: width } },
        _react2.default.createElement(
          _Table.TableBody,
          null,
          rows.map(function (row, i) {
            return _react2.default.createElement(
              _Table.TableRow,
              { key: i, className: classes.row, style: { zIndex: rows.length - i } },
              _react2.default.createElement(
                _Table.TableCell,
                { padding: 'dense', className: classes.col1, style: { maxWidth: width / 3 } },
                _react2.default.createElement(
                  _Typography2.default,
                  { className: classes.col1Text },
                  _react2.default.createElement(_formatted_fieldname2.default, { fieldname: row.key })
                )
              ),
              _react2.default.createElement(
                _Table.TableCell,
                { padding: 'dense', className: (0, _classnames2.default)(classes.col2, (0, _defineProperty3.default)({}, classes.col2Edit, editMode)) },
                editMode ? _react2.default.createElement(ValueCellEdit, {
                  value: row.value,
                  type: row.type,
                  coordFormat: coordFormat,
                  classes: classes,
                  onChange: function onChange(e, _ref5) {
                    var newValue = _ref5.newValue,
                        type = _ref5.type;
                    return onValueChange(row.key, newValue);
                  },
                  fieldMetadata: fieldAnalysis.properties[row.key] }) : _react2.default.createElement(ValueCell, { value: row.value, type: row.type, coordFormat: coordFormat, classes: classes })
              ),
              editMode && _react2.default.createElement(
                _Table.TableCell,
                { className: classes.col3 },
                _react2.default.createElement(
                  _Tooltip2.default,
                  { title: _react2.default.createElement(_reactIntl.FormattedMessage, messages.visibility) },
                  _react2.default.createElement(
                    _IconButton2.default,
                    {
                      style: { color: row.visible ? 'initial' : '#999999' },
                      onClick: function onClick(e) {
                        return onVisibilityChange(row.key, !row.visible);
                      } },
                    row.visible ? _react2.default.createElement(_Visibility2.default, null) : _react2.default.createElement(_VisibilityOff2.default, null)
                  )
                )
              )
            );
          })
        )
      );
    }
  );
};

function getRows(feature, fieldAnalysis, visibleFields, fieldOrder, editMode) {
  var rows = (0, _keys2.default)(fieldAnalysis.properties).map(function (key) {
    return {
      key: key,
      value: feature.properties[key],
      type: fieldAnalysis.properties[key].type,
      visible: visibleFields.indexOf(key) > -1
    };
  }).filter(function (row) {
    return editMode || visibleFields.indexOf(row.key) > -1 && (typeof row.value !== 'string' || row.value.length) && typeof row.value !== 'undefined';
  });

  if (feature.geometry) {
    rows.unshift({
      key: 'location',
      value: feature.geometry && feature.geometry.coordinates,
      type: _constants.FIELD_TYPE_LOCATION,
      visible: visibleFields.indexOf('location') > -1
    });
  }
  // Sort rows by `fieldOrder` from state, if an order is set, if not then sort lexically.
  return rows.sort(function (a, b) {
    var orderA = typeof fieldOrder[a.key] !== 'undefined' ? fieldOrder[a.key] : Infinity;
    var orderB = typeof fieldOrder[b.key] !== 'undefined' ? fieldOrder[b.key] : Infinity;
    if (orderA === Infinity && orderB === Infinity) {
      return lexicalSort(a, b);
    } else {
      return orderA - orderB;
    }
  });
}

function lexicalSort(a, b) {
  var nameA = a.key.toUpperCase(); // ignore upper and lowercase
  var nameB = b.key.toUpperCase(); // ignore upper and lowercase
  if (nameA < nameB) {
    return -1;
  }
  if (nameA > nameB) {
    return 1;
  }
  // names must be equal
  return 0;
}

exports.default = (0, _styles.withStyles)(styles)(FeatureTable);
//# sourceMappingURL=table.js.map