'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _reactRedux = require('react-redux');

var _omit = require('lodash/omit');

var _omit2 = _interopRequireDefault(_omit);

var _redux = require('redux');

var _action_creators = require('../action_creators');

var actionCreators = _interopRequireWildcard(_action_creators);

var _general_helpers = require('../util/general_helpers');

var _field_analysis = require('../selectors/field_analysis');

var _field_analysis2 = _interopRequireDefault(_field_analysis);

var _filterable_features = require('../selectors/filterable_features');

var _filterable_features2 = _interopRequireDefault(_filterable_features);

var _filtered_features = require('../selectors/filtered_features');

var _filtered_features2 = _interopRequireDefault(_filtered_features);

var _mapbox_filter = require('../selectors/mapbox_filter');

var _mapbox_filter2 = _interopRequireDefault(_mapbox_filter);

var _field_mapping = require('../selectors/field_mapping');

var _field_mapping2 = _interopRequireDefault(_field_mapping);

var _color_index = require('../selectors/color_index');

var _color_index2 = _interopRequireDefault(_color_index);

var _visible_fields = require('../selectors/visible_fields');

var _visible_fields2 = _interopRequireDefault(_visible_fields);

function _interopRequireWildcard(obj) { if (obj && obj.__esModule) { return obj; } else { var newObj = {}; if (obj != null) { for (var key in obj) { if (Object.prototype.hasOwnProperty.call(obj, key)) newObj[key] = obj[key]; } } newObj.default = obj; return newObj; } }

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

var CustomContainer = function CustomContainer(props) {
  return (0, _general_helpers.createElement)(props.component, (0, _omit2.default)(props, 'component'));
};

function mapStateToProps(state) {
  return {
    center: state.mapPosition.center,
    zoom: state.mapPosition.zoom,
    mapStyle: state.mapStyle,
    settings: state.settings,
    features: (0, _filterable_features2.default)(state),
    fieldAnalysis: (0, _field_analysis2.default)(state),
    fieldOrder: state.fieldOrder,
    filter: (0, _mapbox_filter2.default)(state),
    filteredFeatures: (0, _filtered_features2.default)(state),
    fieldMapping: (0, _field_mapping2.default)(state),
    colorIndex: (0, _color_index2.default)(state),
    visibleFields: (0, _visible_fields2.default)(state)
  };
}

exports.default = (0, _reactRedux.connect)(mapStateToProps, function (dispatch) {
  return (0, _redux.bindActionCreators)(actionCreators, dispatch);
})(CustomContainer);
//# sourceMappingURL=custom_container.js.map