'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _getPrototypeOf = require('babel-runtime/core-js/object/get-prototype-of');

var _getPrototypeOf2 = _interopRequireDefault(_getPrototypeOf);

var _classCallCheck2 = require('babel-runtime/helpers/classCallCheck');

var _classCallCheck3 = _interopRequireDefault(_classCallCheck2);

var _createClass2 = require('babel-runtime/helpers/createClass');

var _createClass3 = _interopRequireDefault(_createClass2);

var _possibleConstructorReturn2 = require('babel-runtime/helpers/possibleConstructorReturn');

var _possibleConstructorReturn3 = _interopRequireDefault(_possibleConstructorReturn2);

var _inherits2 = require('babel-runtime/helpers/inherits');

var _inherits3 = _interopRequireDefault(_inherits2);

var _defineProperty2 = require('babel-runtime/helpers/defineProperty');

var _defineProperty3 = _interopRequireDefault(_defineProperty2);

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _reactRedux = require('react-redux');

var _styles = require('material-ui/styles');

var _redux = require('redux');

var _find = require('lodash/find');

var _find2 = _interopRequireDefault(_find);

var _custom_container = require('./custom_container');

var _custom_container2 = _interopRequireDefault(_custom_container);

var _top_bar = require('./top_bar');

var _top_bar2 = _interopRequireDefault(_top_bar);

var _action_creators = require('../action_creators');

var actionCreators = _interopRequireWildcard(_action_creators);

var _Dialog = require('material-ui/Dialog');

var _Dialog2 = _interopRequireDefault(_Dialog);

var _filter = require('../components/filter');

var _filter2 = _interopRequireDefault(_filter);

var _feature_detail = require('../components/feature_detail');

var _feature_detail2 = _interopRequireDefault(_feature_detail);

var _settings = require('../components/settings');

var _settings2 = _interopRequireDefault(_settings);

var _map = require('../components/map');

var _map2 = _interopRequireDefault(_map);

var _report = require('../components/report');

var _report2 = _interopRequireDefault(_report);

var _media = require('../components/media');

var _media2 = _interopRequireDefault(_media);

var _general_helpers = require('../util/general_helpers');

function _interopRequireWildcard(obj) { if (obj && obj.__esModule) { return obj; } else { var newObj = {}; if (obj != null) { for (var key in obj) { if (Object.prototype.hasOwnProperty.call(obj, key)) newObj[key] = obj[key]; } } newObj.default = obj; return newObj; } }

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

var styles = function styles(theme) {
  var _modalPaper;

  return {
    outer: {
      position: 'fixed',
      top: 0,
      bottom: 0,
      width: '100%',
      display: 'flex',
      flexDirection: 'column',
      '@media print': {
        display: 'block',
        position: 'static',
        bottom: 'auto'
      }
    },
    inner: {
      display: 'flex',
      flex: 1,
      '@media print': {
        display: 'block'
      }
    },
    modalRoot: {
      display: 'block',
      overflow: 'scroll'
    },
    modalPaper: (_modalPaper = {}, (0, _defineProperty3.default)(_modalPaper, theme.breakpoints.down('sm'), {
      padding: 0
    }), (0, _defineProperty3.default)(_modalPaper, 'backgroundColor', 'initial'), (0, _defineProperty3.default)(_modalPaper, 'maxHeight', 'initial'), (0, _defineProperty3.default)(_modalPaper, 'minHeight', '100%'), (0, _defineProperty3.default)(_modalPaper, 'position', 'relative'), (0, _defineProperty3.default)(_modalPaper, 'margin', '0 auto'), (0, _defineProperty3.default)(_modalPaper, 'padding', 32), (0, _defineProperty3.default)(_modalPaper, 'boxShadow', 'none'), (0, _defineProperty3.default)(_modalPaper, 'boxSizing', 'border-box'), (0, _defineProperty3.default)(_modalPaper, 'display', 'flex'), (0, _defineProperty3.default)(_modalPaper, 'alignItems', 'center'), (0, _defineProperty3.default)(_modalPaper, 'justifyContent', 'center'), (0, _defineProperty3.default)(_modalPaper, 'pointerEvents', 'none'), _modalPaper),
    modalInner: {
      pointerEvents: 'auto'
    },
    view: {
      flex: 3,
      position: 'relative'
    },
    actionButton: {
      position: 'absolute',
      bottom: 36,
      right: 36,
      zIndex: 2
    }
  };
};

var IndexRoute = function (_React$Component) {
  (0, _inherits3.default)(IndexRoute, _React$Component);

  function IndexRoute() {
    (0, _classCallCheck3.default)(this, IndexRoute);
    return (0, _possibleConstructorReturn3.default)(this, (IndexRoute.__proto__ || (0, _getPrototypeOf2.default)(IndexRoute)).apply(this, arguments));
  }

  (0, _createClass3.default)(IndexRoute, [{
    key: 'componentWillMount',
    value: function componentWillMount() {
      this.redirectIfNecessary(this.props);
    }
  }, {
    key: 'componentWillReceiveProps',
    value: function componentWillReceiveProps(nextProps) {
      this.redirectIfNecessary(nextProps);
    }
  }, {
    key: 'redirectIfNecessary',
    value: function redirectIfNecessary(_ref) {
      var activeModal = _ref.activeModal,
          activeView = _ref.activeView,
          views = _ref.views,
          redirectView = _ref.redirectView;

      if (!(0, _find2.default)(views, { id: activeView })) return redirectView(views[0].id);
      if (activeModal && !getModalComponent(activeModal)) redirectView(activeView);
    }
  }, {
    key: 'render',
    value: function render() {
      var _props = this.props,
          activeView = _props.activeView,
          activeModal = _props.activeModal,
          actionButton = _props.actionButton,
          classes = _props.classes,
          views = _props.views,
          switchView = _props.switchView,
          settingsTab = _props.settingsTab,
          toolbarButtons = _props.toolbarButtons,
          toolbarTitle = _props.toolbarTitle;

      var ModalComponent = getModalComponent(activeModal);
      var ViewComponent = getViewComponent(activeView, views);

      return _react2.default.createElement(
        'div',
        { className: classes.outer },
        _react2.default.createElement(_top_bar2.default, { views: views, activeView: activeView, onChangeTab: switchView, buttons: toolbarButtons, title: toolbarTitle }),
        _react2.default.createElement(
          'div',
          { className: classes.inner },
          _react2.default.createElement(_filter2.default, null),
          _react2.default.createElement(
            'div',
            { className: classes.view },
            _react2.default.createElement(_custom_container2.default, { component: ViewComponent })
          ),
          actionButton && _react2.default.createElement(
            'div',
            { className: classes.actionButton },
            (0, _general_helpers.createElement)(actionButton)
          )
        ),
        _react2.default.createElement(
          _Dialog2.default,
          {
            onRequestClose: this.props.closeModal,
            open: !!ModalComponent,
            fullWidth: true,
            classes: { root: classes.modalRoot, paper: classes.modalPaper } },
          ModalComponent && _react2.default.createElement(ModalComponent, { activeTabId: settingsTab, onCloseClick: this.props.closeModal, className: classes.modalInner })
        )
      );
    }
  }]);
  return IndexRoute;
}(_react2.default.Component);

IndexRoute.defaultProps = {
  views: [{
    id: 'map',
    component: _map2.default
  }, {
    id: 'media',
    component: _media2.default
  }, {
    id: 'report',
    component: _report2.default
  }]
};

function getModalComponent(modal) {
  switch (modal) {
    case 'feature':
      return _feature_detail2.default;
    case 'settings':
      return _settings2.default;
    default:
  }
}

function getViewComponent(activeView, views) {
  var view = (0, _find2.default)(views, { id: activeView });
  if (!view) return function () {
    return _react2.default.createElement('div', null);
  };
  return view.component;
}

exports.default = (0, _reactRedux.connect)(function (state) {
  return state.ui || {};
}, function (dispatch) {
  return (0, _redux.bindActionCreators)(actionCreators, dispatch);
})((0, _styles.withStyles)(styles)(IndexRoute));
//# sourceMappingURL=index_route.js.map